<xsl:stylesheet
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  
  <xsl:template match="/items">
    <html>
      <head>
	<title>A URIResolverImpl test</title>
      </head>

      <body>

	<h1>A URIResolverImpl test</h1>
	
	<p>
	  Below is a table of the item names as found in test.xml,
	  and the matching descriptions as found in data/descriptions.xml,
	  sourced via a call to document() and using the XMLDB
	  URIResolverImpl.
	</p>

	<p>
	  The overall effect is somewhat like that of a hashtable, or hash-map.
	</p>

	<table>
	  <tr>
	    <th>Name</th>
	    <th>Description</th>
	  </tr>
	  <xsl:apply-templates />
	</table>
      </body>
    </html>
  </xsl:template>

  <!-- the magic occurs here -->

  <xsl:template match="item">
    <!-- store the item's name for easy access -->
    <xsl:variable name="item" select="@name"/>

    <!-- retreive the description document -->
    <xsl:variable
      name="description"
      select="document('xmldb:///description.xml')"/>

    <tr>
      <td>
p	<xsl:value-of select="$item"/>
      </td>
      <td>
	<xsl:value-of select="$description/hashtable/item[@key = $item]/@value"/>
      </td>
    </tr>
  </xsl:template>

</xsl:stylesheet>